<?php

namespace PB\WithdrawalQueue\Api\Controller;

use PB\WithdrawalQueue\Addon;

class PaymentSystems extends \XF\Api\Controller\AbstractController
{
	/**
	 * @api-desc Gets the API list of payment systems.
	 *
	 * @api-out PB_WithdrawalQueue_PaymentSystem[]
	 *
	 * @return \XF\Api\Mvc\Reply\ApiResult
	 * @throws \XF\Mvc\Reply\Exception
	 */
	public function actionGet()
	{
		$this->assertApiScope('pb_wq_payment_system:read');

		$paymentSystemFinder = $this->setupPaymentSystemFinder();
		$paymentSystems = $paymentSystemFinder->fetch();
		$apiResults = $paymentSystems->toApiResults();

		return $this->apiResult($apiResults);
	}

	protected function setupPaymentSystemFinder()
	{
		$finder = $this->finder(Addon::shortName('PaymentSystem'));
		$finder->order('display_order', 'DESC');

		return $finder;
	}
}