<?php


namespace PB\WithdrawalQueue\CurrencyHandler;

use XF\Entity\User;
use XF\Mvc\Entity\Entity;

abstract class AbstractHandler
{
	public abstract function getCurrencyOptionsData();

	public abstract function getCurrencyTitle($currencyId);

	public abstract function getFormattedAmount($amount, $currencyId);

	public abstract function getChargedAmount($amount, $currencyId);

	public abstract function testCharge(Entity $content, User $user, $amount, $currencyId, &$errors = []): bool;

	public abstract function charge(Entity $content, User $user, $amount, $currencyId);

	public abstract function testRefund(Entity $content, User $user, $amount, $currencyId, &$errors = []): bool;

	public abstract function refund(Entity $content, User $user, $amount, $currencyId);
}
