<?php

namespace PB\WithdrawalQueue\Entity;

use PB\WithdrawalQueue\Addon;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int $system_id
 * @property string $field_id
 *
 * RELATIONS
 * @property RequisiteField $Field
 * @property PaymentSystem $PaymentSystem
 */
class PaymentSystemField extends \XF\Entity\AbstractFieldMap
{
	public static function getContainerKey()
	{
		return 'system_id';
	}

	public static function getStructure(Structure $structure)
	{
		self::setupDefaultStructure($structure, 'xf_pb_wq_payment_system_field', Addon::shortName('PaymentSystemField'), Addon::shortName('RequisiteField'));

		$structure->relations['PaymentSystem'] = [
			'entity' => Addon::shortName('PaymentSystem'),
			'type' => self::TO_ONE,
			'conditions' => 'system_id',
			'primary' => true
		];

		return $structure;
	}
}