<?php

namespace PB\WithdrawalQueue\Entity;

use PB\WithdrawalQueue\Addon;
use XF\Mvc\Entity\Structure;

/**
 * RELATIONS
 * @property \XF\Mvc\Entity\AbstractCollection|PaymentSystemField[] $PaymentSystemField
 */
class RequisiteField extends \XF\Entity\AbstractField
{
	protected function getClassIdentifier()
	{
		return Addon::shortName('RequisiteField');
	}

	protected static function getPhrasePrefix()
	{
		return Addon::prefix('requisite_field');
	}

	protected function _postDelete()
	{
		parent::_postDelete();

		/** @var \PB\WithdrawalQueue\Repository\PaymentSystemField $repo */
		$repo = $this->repository(Addon::shortName('PaymentSystemField'));
		$repo->removeFieldAssociations($this);

		$this->db()->delete('xf_pb_wq_requisite_field_value', 'field_id = ?', $this->field_id);
	}

	public static function getStructure(Structure $structure)
	{
		self::setupDefaultStructure(
			$structure,
			'xf_pb_wq_requisite_field',
			Addon::shortName('RequisiteField'),
			[
				'groups' => ['below_withdraw'],
				'has_wrapper_template' => true
			]
		);

		$structure->relations['PaymentSystemFields'] = [
			'entity' => Addon::shortName('PaymentSystemField'),
			'type' => self::TO_MANY,
			'conditions' => 'field_id'
		];

		return $structure;
	}

}