<?php

namespace PB\WithdrawalQueue\Entity;

use PB\WithdrawalQueue\Addon;
use XF\Mvc\Entity\Structure;

/**
 * @property int $requisite_id
 * @property string $field_id
 * @property string $field_value
 */
class RequisiteFieldValue extends \XF\Mvc\Entity\Entity
{
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'pb_wq_requisite_field_value';
		$structure->shortName = Addon::shortName('RequisiteFieldValue');
		$structure->primaryKey = ['requisite_id', 'field_id'];
		$structure->columns = [
			'requisite_id' => ['type' => self::UINT, 'required' => true],
			'field_id' => ['type' => self::STR, 'maxLength' => 25,
				'match' => 'alphanumeric'
			],
			'field_value' => ['type' => self::STR, 'default' => '']
		];
		$structure->getters = [];
		$structure->relations = [];

		return $structure;
	}

}