<?php


namespace PB\WithdrawalQueue\Notifier\Withdraw;


use PB\WithdrawalQueue\Entity\Withdraw as WithdrawEntity;
use XF\App;
use XF\Entity\User;
use XF\Notifier\AbstractNotifier;

class Reject extends AbstractNotifier
{
	/**
	 * @var WithdrawEntity
	 */
	protected $withdraw;

	public function __construct(App $app, WithdrawEntity $withdraw)
	{
		parent::__construct($app);

		$this->withdraw = $withdraw;
	}

	public function canNotify(User $user)
	{
		return $user->user_id != \XF::visitor()->user_id;
	}

	public function sendAlert(User $user)
	{
		$visitor = \XF::visitor();
		$withdraw = $this->withdraw;

		return $this->basicAlert(
			$user,
			$visitor->user_id,
			$visitor->username,
			$withdraw->getEntityContentType(),
			$withdraw->getEntityId(),
			'reject'
		);
	}
}