<?php

namespace PB\WithdrawalQueue\Pub\Controller;

class AbstractBasicController extends \XF\Pub\Controller\AbstractController
{
	protected $viewFormatter = '';
	protected $templateFormatter = '';
	protected $routePrefix = '';
	protected $entityIdentifier = '';
	protected $primaryKey = '';

	public function setFormatters($view, $template)
	{
		$this->viewFormatter = $view;
		$this->templateFormatter = $template;
	}

	public function setRoutePrefix($prefix)
	{
		$this->routePrefix = $prefix;
	}

	public function setPrimaryKey($key)
	{
		$this->primaryKey = $key;
	}

	public function setEntityIdentifier($identifier)
	{
		$this->entityIdentifier = $identifier;
	}

	protected function formatView($type)
	{
		$formatter = $this->viewFormatter;

		if (is_string($formatter))
		{
			return sprintf($formatter, $type);
		}
		else if ($formatter instanceof \Closure)
		{
			return $formatter($type);
		}
		else
		{
			return '';
		}
	}

	protected function formatTemplate($type)
	{
		$formatter = $this->templateFormatter;

		if (is_string($formatter))
		{
			return sprintf($formatter, $type);
		}
		else if ($formatter instanceof \Closure)
		{
			return $formatter($type);
		}
		else
		{
			return '';
		}
	}
}