<?php

namespace PB\WithdrawalQueue\Repository;

use PB\WithdrawalQueue\Addon;

class PaymentSystemField extends \XF\Repository\AbstractFieldMap
{
	protected function getMapEntityIdentifier()
	{
		return Addon::shortName('PaymentSystemField');
	}

	protected function getAssociationsForField(\XF\Entity\AbstractField $field)
	{
		return $field->getRelation('PaymentSystemFields');
	}

	protected function updateAssociationCache(array $cache)
	{
		$systemIds = array_keys($cache);

		/** @var \PB\WithdrawalQueue\Entity\PaymentSystem $paymentSystem */
		$paymentSystems = $this->em->findByIds(Addon::shortName('PaymentSystem'), $systemIds);

		foreach ($paymentSystems AS $paymentSystem)
		{
			$paymentSystem->field_cache = $cache[$paymentSystem->system_id];
			$paymentSystem->saveIfChanged();
		}
	}
}