<?php

namespace PB\WithdrawalQueue\Service\Withdraw;

class Export extends \XF\Service\AbstractService
{
	protected $exportData = [];

	public function __construct(\XF\App $app, $exportData)
	{
		parent::__construct($app);
		$this->exportData = $exportData;
	}

	public function exportToCsv()
	{
		$csv = $this->createCsv();

		$typeHeaders = [];
		$typeValues = [];

		foreach ($this->exportData as $value)
		{
			$typeHeaders = array_keys($value);
			$typeValues[] = $value;
		}

		$csv->insertOne($typeHeaders);
		$csv->insertAll($typeValues);

		return $csv;
	}

	protected function createCsv()
	{
		$csv = \League\Csv\Writer::createFromString('');
		$csv->setDelimiter(';');
		$csv->setOutputBOM(\League\Csv\Writer::BOM_UTF8);

		return $csv;
	}
}