<?php

namespace PB\WithdrawalQueue\WalletType;


abstract class AbstractHandler
{
	/**
	 * @var \PB\WithdrawalQueue\Entity\PaymentSystem
	 */
	protected $paymentSystem;

	public function __construct(\PB\WithdrawalQueue\Entity\PaymentSystem $paymentSystem)
	{
		$this->paymentSystem = $paymentSystem;
	}

	public function getTypeTitle()
	{
		return '';
	}

	public function getTypeExplain()
	{
		return '';
	}

	public abstract function getInputTemplateName(): string;

	public function getInputTemplateData()
	{
		return [
			'typeTitle' => $this->getTypeTitle(),
			'typeExplain' => $this->getTypeExplain(),
		];
	}

	public function validate($wallet, &$error = null): bool
	{
		return true;
	}
}
