<?php

namespace PB\WithdrawalQueue\WalletType;

class Email extends AbstractHandler
{
	public function getInputTemplateName(): string
	{
		return 'pb_wq_requisite_wallet_input_template_email';
	}

	public function validate($wallet, &$error = null): bool
	{
		/** @var \XF\Validator\Email $emailValidator */
		$emailValidator = \XF::app()->validator('Email');
		if (!$emailValidator->isValid($wallet, $errorKey))
		{
			if ($errorKey == 'banned')
			{
				$error = \XF::phrase('email_address_you_entered_has_been_banned_by_administrator');
			}
			else if ($errorKey == 'typo')
			{
				$error = \XF::phrase('email_address_you_entered_appears_have_typo');
			}
			else
			{
				$error = \XF::phrase('please_enter_valid_email');
			}

			return false;
		}

		return true;
	}
}
